SYSTEMD-STUB(7)

NAME
systemd-stub, linuxx64.efi.stub, linuxia32.efi.stub, linuxaa64.efi.stub - A simple UEFI kernel boot stub

SYNOPSIS

/usr/lib/systemd/boot/efi/linuxx64.efi.stub

/usr/lib/systemd/boot/efi/linuxia32.efi.stub

/usr/lib/systemd/boot/efi/linuxaa64.efi.stub

DESCRIPTION

systemd-stub (stored in per-architecture files linuxx64.efi.stub, linuxia32.efi.stub, linuxaa64.efi.stub on disk) is a simple UEFI boot stub. An UEFI boot stub is attached to a Linux kernel binary image, and is a piece of code that runs in the UEFI firmware environment before transitioning into the Linux kernel environment. The UEFI boot stub ensures a Linux kernel is executable as regular UEFI binary, and is able to do various preparations before switching the system into the Linux world.

The UEFI boot stub looks for various resources for the kernel invocation inside the UEFI PE binary itself. This allows combining various resources inside a single PE binary image, which may then be signed via UEFI SecureBoot as a whole, covering all individual resources at once. Specifically it may include:

    • The ELF Linux kernel images will be looked for in the ".linux" PE section of the executed image.

    • The initial RAM disk (initrd) will be looked for in the ".initrd" PE section.

    • The kernel command line to pass to the invoked kernel will be looked for in the ".cmdline" PE section.

    • A boot splash (in Windows .BMP format) to show on screen before invoking the kernel will be looked for in the ".splash" PE section.

If UEFI SecureBoot is enabled and the ".cmdline" section is present in the executed image, any attempts to override the kernel command line by passing one as invocation parameters to the EFI binary are ignored. Thus, in order to allow overriding the kernel command line, either disable UEFI SecureBoot, or don't include a kernel command line PE section in the kernel image file. If a command line is accepted via EFI invocation parameters to the EFI binary it is measured into TPM PCR 8 (if a TPM is present).

COMPANION FILES

The systemd-stub UEFI boot stub automatically collects two types of auxiliary companion files optionally placed in a drop-in directory next to the EFI binary and dynamically generates cpio initrd archives from them, and passes them to the kernel. Specifically:

    • For a kernel binary called foo.efi it will look for files with the .cred suffix in a directory named foo.efi.extra.d/, next to it. A cpio archive is generated from all files found that way, placing them in the /.extra/credentials/ directory of the initrd file hierarchy. The main initrd may then access them in this directory. This is supposed to be used to store auxiliary, encrypted, authenticated credentials for use with LoadCredentialEncrypted= in the UEFI System Partition. See systemd.exec(5) for details on encrypted credentials. The generated cpio archive is measured into TPM PCR 4 (if a TPM is present)

    • Similar, files foo.efi.extra.d/*.raw are packed up as cpio archive and placed in the /.extra/sysext/ directory in the initrd file hierarchy. This is supposed to be used to pass additional system extension images to the initrd. See systemd-sysext(8) for details on system extension images. The generated cpio archive containing these system extension images is measured into TPM PCR 8 (if a TPM is present).

Both mechanisms may be used to parameterize and extend trusted (i.e. signed), immutable initrd images in a reasonably safe way: all data they contain is measured into TPM PCRs. On access they should be further validated: in case of the credentials case by encrypting/authenticating them via TPM, as exposed by systemd-creds encrypt -T (see systemd-creds(1) for details); in case of the system extension images by using signed Verity images.

EFI VARIABLES

The following EFI variables are defined, set and read by systemd-stub, under the vendor UUID "4a67b082-0a4c-41cf-b6c7-440b29bb8c4f", for communication between the boot stub and the OS:

LoaderDevicePartUUID
    Contains the partition UUID of the EFI System Partition the EFI image was run from. systemd-gpt-auto-generator(8) uses this information to automatically find the disk booted from, in order to discover various other partitions on the same disk automatically.

LoaderFirmwareInfo, LoaderFirmwareType
    Brief firmware information. Use bootctl(1) to view this data.

LoaderImageIdentifier
    The path of EFI executable, relative to the EFI System Partition's root directory. Use bootctl(1) to view this data.

StubInfo
    Brief stub information. Use bootctl(1) to view this data.

Note that some of the variables above may also be set by the boot loader. The stub will only set them if they aren't set already. Some of these variables are defined by the Boot Loader Interface[1].

ASSEMBLING KERNEL IMAGES

In order to assemble an UEFI PE kernel image from various components as described above, use an objcopy(1) command line like this:

    objcopy \
        --add-section .osrel=os-release --change-section-vma .osrel=0x20000 \
        --add-section .cmdline=cmdline.txt --change-section-vma .cmdline=0x30000 \
        --add-section .splash=splash.bmp --change-section-vma .splash=0x40000 \
        --add-section .linux=vmlinux --change-section-vma .linux=0x2000000 \
        --add-section .initrd=initrd.cpio --change-section-vma .initrd=0x3000000 \
        /usr/lib/systemd/boot/efi/linuxx64.efi.stub \
        foo-unsigned.efi

This generates one PE executable file foo-unsigned.efi from the six individual files for OS release information, kernel command line, boot splash image, kernel image, main initrd and UEFI boot stub.

To then sign the resulting image for UEFI SecureBoot use an sbsign(1) command like the following:

    sbsign \
        --key mykey.pem \
        --cert mykey.crt \
        --output foo.efi \
        foo-unsigned.efi

This expects a pair of X.509 private key and certificate as parameters and then signs the UEFI PE executable we generated above for UEFI SecureBoot and generates a signed UEFI PE executable as result.

SEE ALSO

systemd-boot(7), systemd.exec(5), systemd-creds(1), systemd-sysext(8), Boot Loader Specification[2], Boot Loader Interface[1], objcopy(1), sbsign(1)

NOTES

1.  Boot Loader Interface
    https://systemd.io/BOOT_LOADER_INTERFACE

2.  Boot Loader Specification
    https://systemd.io/BOOT_LOADER_SPECIFICATION